import { App } from '@alilc/lowcode-renderer-core';
import { AppBase } from '@alilc/lowcode-renderer-core';
import { AppOptionsBase } from '@alilc/lowcode-renderer-core';
import { ComponentType } from 'react';
import { ComponentWidget } from '@alilc/lowcode-renderer-core';
import type { CreateComponentBaseOptions } from '@alilc/lowcode-renderer-core';
import type { IntlApi } from '@alilc/lowcode-renderer-core';
import type { LowCodeComponent } from '@alilc/lowcode-renderer-core';
import type { ReactInstance } from 'react';
import { TextWidget } from '@alilc/lowcode-renderer-core';

export declare interface AppOptions extends AppOptionsBase {
    dataSourceCreator: any;
    faultComponent?: ComponentType<any>;
}

declare interface ComponentOptions<C = ComponentType<any>> extends CreateComponentBaseOptions<ReactComponentLifeCycle> {
    componentsRecord: Record<string, C | LowCodeComponent>;
    intl: IntlApi;
    displayName?: string;
    beforeElementCreate?(widget: TextWidget<C> | ComponentWidget<C>): void;
    componentRefAttached?(widget: ComponentWidget<C>, instance: ReactInstance): void;
}

export declare const createApp: (options: AppOptions) => Promise<App<ReactRender>>;

export declare function createComponent(options: ComponentOptions): ComponentType<any>;

export declare type ReactApp = App<ReactRender>;

declare type ReactComponentLifeCycle = 'constructor' | 'render' | 'componentDidMount' | 'componentDidUpdate' | 'componentWillUnmount' | 'componentDidCatch';

export declare interface ReactRender extends AppBase {
}

export { }
